/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH & Co. KG                *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.28                          *
*        Compiled Jan 30 2015, 16:41:06                              *
*        (c) 2015 Segger Microcontroller GmbH & Co. KG               *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

// USER START (Optionally insert additional includes)
#include "includes.h"
#include "app.h"
#include "DIALOG.h"
#include "./Bsp/wm8978/bsp_wm8978.h"
#include "string.h"
#include "mp3dec.h"
// USER END


/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
// USER START (Optionally insert additional defines)
/*--------------------  (ʹU2C.exeС)  ------------------------------------*/
/*
*  U2C.exeСʹ÷½һTXTıļתıΪUTF8ʽļ
*  U2C.exeСߣȵļļȻѡ"Convert"תɺͬ·
*  ͬ.cļ
*/
#define UTF8_MUSICDLG       "\xe9\x9f\xb3\xe4\xb9\x90\xe6\x92\xad\xe6\x94\xbe\xe5\x99\xa8"  //ֲ
#define UTF8_LYRIC          "\xe6\xad\x8c\xe8\xaf\x8d" //
#define UTF8_SONG           "\xe6\xad\x8c\xe6\x9b\xb2" //
#define UTF8_SDCARDERROR    "SD\xe5\x8d\xa1\xe8\xaf\xbb\xe5\x8f\x96\xe5\xa4\xb1\xe8\xb4\xa5"//SDȡʧ
/*-----------------------------------------------------------------------------------*/

#define MUSIC_MAX_NUM           20
#define FILE_NAME_LEN           101			
#define MUSIC_NAME_LEN          51		
#define LYRIC_MAX_SIZE          80				
#define MAX_LINE_LEN            90				
#define _DF1S                   0x81
#define BUFFER_SIZE             1024*8
#define LYRIC_MAX_SIZE			    80					
#define MP3BUFFER_SIZE          2304		
#define INPUTBUF_SIZE           3000	

/* ״̬ */
typedef enum
{
	STA_IDLE = 0,	/* ״̬ */
	STA_PLAYING,	/* ״̬ */
	STA_STOP,	    /* ֹͣ״̬ */
  STA_SWITCH,   /* и״̬ */
}PLAYER_STATE;

typedef struct
{
	PLAYER_STATE ucStatus;			/* ״̬0ʾ1 ʾ */	
	uint8_t ucVolume;			      /* ǰ */
  uint8_t ucMute;             /* ־ 10  */
	uint32_t ucFreq;			      /* Ƶ */
  uint32_t ucbps;            /*  ÿ봫Ͷٸλ */
}MUSIC_TYPE;


typedef __packed struct 
{ 
	uint8_t 	indexsize; 	
  uint8_t		length_tbl[LYRIC_MAX_SIZE]; 
 	uint16_t	addr_tbl[LYRIC_MAX_SIZE];										
 	int32_t		curtime;										
  int32_t		oldtime;	
  int32_t 	time_tbl[LYRIC_MAX_SIZE];		
}LYRIC;

// USER END

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/

// USER START (Optionally insert additional static data)
extern GUI_CONST_STORAGE GUI_BITMAP bmback;
extern GUI_CONST_STORAGE GUI_BITMAP bmnext;
extern GUI_CONST_STORAGE GUI_BITMAP bmplay;
extern GUI_CONST_STORAGE GUI_BITMAP bmstop;
extern GUI_CONST_STORAGE GUI_BITMAP bmvoice;
extern GUI_CONST_STORAGE GUI_BITMAP bmvolume_mute;
extern GUI_CONST_STORAGE GUI_BITMAP bmvolume_medium;

static uint8_t play_index = 0;

static GUI_HMEM hMEM_Music;
static char *pMEM_Music;
static uint16_t *buffer_Music[2];
static uint8_t *inputbuf;
static uint8_t chgsch;

static MUSIC_TYPE Music;
static uint8_t Isread_Music=0;
static uint8_t bufflag_Music=0;//0 -> use musicbuf[0][]; 1 -> use musicbuf[1][]

static char path[100]="0:";																		
static uint8_t  file_num = 0;																	
static unsigned char playlist[MUSIC_MAX_NUM][FILE_NAME_LEN];
static unsigned char lcdlist[MUSIC_MAX_NUM][MUSIC_NAME_LEN];

static LYRIC *lrc;

static HMP3Decoder		Mp3Decoder;			/* mp3ָ	*/
static MP3FrameInfo		Mp3FrameInfo;		/* mP3֡Ϣ  */

// USER END

/*********************************************************************
*
*       _aDialogCreate
*/
static const GUI_WIDGET_CREATE_INFO _aDialogCreateMusic[] = {
  { FRAMEWIN_CreateIndirect, "music",     0,               0,   0,   800, 480, 0, 0x64, 0 },
  { TEXT_CreateIndirect,     "lyric1",    GUI_ID_TEXT0,    400, 180, 390, 20, 0, 0x0,  0 },
  { TEXT_CreateIndirect,     "lyric2",    GUI_ID_TEXT1,    400, 200, 390, 40,  0, 0x0,  0 },
  { TEXT_CreateIndirect,     "lyric3",    GUI_ID_TEXT2,    400, 240, 390, 20, 0, 0x0,  0 },
  
  { TEXT_CreateIndirect,     "mucis",     GUI_ID_TEXT3,    0,   0,   395, 35,  0, 0x0,  0 },
  { TEXT_CreateIndirect,     "ptime",     GUI_ID_TEXT4,    10,  343, 50,  20,  0, 0x0,  0 },
  { TEXT_CreateIndirect,     "atime",     GUI_ID_TEXT5,    340, 343, 50,  20,  0, 0x0,  0 },
  { TEXT_CreateIndirect,     "volume",    GUI_ID_TEXT6,    303, 417, 50,  20,  0, 0x0,  0 },
  
  { LISTBOX_CreateIndirect,  "musiclist", GUI_ID_LISTBOX0, 5,   40,  390, 275, 0, 0x0,  0 },
  { SLIDER_CreateIndirect,   "schedule",  GUI_ID_SLIDER0,  10,  315, 380, 30,  0, 0x0,  0 },
  { SLIDER_CreateIndirect,   "volume",    GUI_ID_SLIDER1,  100, 410, 200, 30,  0, 0x0,  0 }, 
  { BUTTON_CreateIndirect,   "play",      GUI_ID_BUTTON0,  180, 355, 40,  40,  0, 0x0,  0 },  
  { BUTTON_CreateIndirect,   "back",      GUI_ID_BUTTON1,  100, 355, 40,  40,  0, 0x0,  0 },
  { BUTTON_CreateIndirect,   "next",      GUI_ID_BUTTON2,  260, 355, 40,  40,  0, 0x0,  0 },  
  { BUTTON_CreateIndirect,   "volume",    GUI_ID_BUTTON3,  72,  418, 20,  15,  0, 0x0,  0 },
  // USER START (Optionally insert additional widgets)
  // USER END
};

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/

// USER START (Optionally insert additional static code)
/**
  * @brief  scan_files ݹɨsdڵĸļ
  * @param  path:ʼɨ·
  * @retval result:ļϵͳķֵ
  */
static FRESULT scan_files (char* path) 
{ 
  FRESULT res; 		//ڵݹ̱޸ĵıȫֱ	
  FILINFO fno; 
  DIR dir; 
  int i; 
  char *fn; 
	char file_name[FILE_NAME_LEN];	
	
#if _USE_LFN 
  static char lfn[_MAX_LFN * (_DF1S ? 2 : 1) + 1]; 	//ļ֧
  fno.lfname = lfn; 
  fno.lfsize = sizeof(lfn); 
#endif 

  
  res = f_opendir(&dir, path); //Ŀ¼
  if (res == FR_OK) 
	{ 
    i = strlen(path); 
    for (;;) 
		{ 
      res = f_readdir(&dir, &fno); 										//ȡĿ¼µ
      if (res != FR_OK || fno.fname[0] == 0) break; 	//ΪʱʾĿȡϣ
#if _USE_LFN 
      fn = *fno.lfname ? fno.lfname : fno.fname; 
#else 
      fn = fno.fname; 
#endif 
      if(strstr(path,"recorder")!=NULL)continue;       //ӹ¼ļ
      if (*fn == '.') continue; 											//ʾǰĿ¼			
      if (fno.fattrib & AM_DIR) 
			{ 																							//Ŀ¼ݹȡ
        sprintf(&path[i], "/%s", fn); 							//ϳĿ¼
        res = scan_files(path);											//ݹ 
        if (res != FR_OK) 
					break; 																		//ʧܣѭ
        path[i] = 0; 
      } 
			else 
			{ 
				//printf("%s/%s\r\n", path, fn);								//ļ
				if(strstr(fn,".wav")||strstr(fn,".WAV")||strstr(fn,".mp3")||strstr(fn,".MP3"))//жǷmp3wavļ
				{
					if ((strlen(path)+strlen(fn)<FILE_NAME_LEN)&&(file_num<MUSIC_MAX_NUM))
					{
						sprintf(file_name, "%s/%s", path, fn);						
						memcpy(playlist[file_num],file_name,strlen(file_name));
						memcpy(lcdlist[file_num],fn,strlen(fn));						
						file_num++;//¼ļ
					}
				}//if mp3||wav
      }//else
    } //for
  } 
  return res; 
}



static uint16_t getonelinelrc(uint8_t *buff,uint8_t *str,int16_t len)
{
	uint16_t i;
	for(i=0;i<len;i++)
	{
		*(str+i)=*(buff+i);
		if((*(buff+i)==0x0A)||(*(buff+i)==0x00))
		{
			*(buff+i)='\0';
			*(str+i)='\0';
			break;
		}
	}
	return (i+1);
}
static void lrc_chg_suffix(uint8_t *name,const char *sfx)
{		    	     
	while(*name!='\0')name++;
	while(*name!='.')name--;
	*(++name)=sfx[0];
	*(++name)=sfx[1];
	*(++name)=sfx[2];
	*(++name)='\0';
}
static void lrc_sequence(LYRIC	*lyric)
{
	uint16_t i=0,j=0;
	uint16_t temp=0;
	if (lyric->indexsize == 0)return;
	
	for(i = 0; i < lyric->indexsize - 1; i++)
	{
		for(j = i+1; j < lyric->indexsize; j++)
		{
			if(lyric->time_tbl[i] > lyric->time_tbl[j])
			{
				temp = lyric->time_tbl[i];
				lyric->time_tbl[i] = lyric->time_tbl[j];
				lyric->time_tbl[j] = temp;

				temp = lyric->addr_tbl[i];
				lyric->addr_tbl[i] = lyric->addr_tbl[j];
				lyric->addr_tbl[j] = temp;
			}
		}
	}	
}
static void lyric_analyze(LYRIC	*lyric,uint8_t *strbuf)
{
	uint8_t strtemp[MAX_LINE_LEN]={0};
	uint8_t *pos=0;
	uint8_t sta=0,strtemplen=0;
	uint16_t lrcoffset=0;
	uint16_t str_len=0,i=0;
	
	pos=strbuf;
	str_len=strlen((const char *)strbuf);
	if(str_len==0)return;
	i=str_len;
	while(--i)
	{
		if(*pos=='[')
			sta=1;
		else if((*pos==']')&&(sta==1))
			sta=2;
	  else if((sta==2)&&(*pos!=' '))
		{
			sta=3;
			break;
		}
		pos++; 
	}
	if(sta!=3)return;	
	lrcoffset=0;
	lyric->indexsize=0;
	while(lrcoffset<=str_len)
	{
		i=getonelinelrc(strbuf+lrcoffset,strtemp,MAX_LINE_LEN);
		lrcoffset+=i;
//		printf("lrcoffset:%d,i:%d\n",lrcoffset,i);
		strtemplen=strlen((const char *)strtemp);
		pos=strtemp;
		while(*pos!='[')
			pos++;
		pos++;
		if((*pos<='9')&&(*pos>='0'))
		{
			lyric->time_tbl[lyric->indexsize]=(((*pos-'0')*10+(*(pos + 1)-'0'))*60+((*(pos+3)-'0')*10+(*(pos+4)-'0')))*100+((*(pos+6)-'0')*10+(*(pos+7)-'0'));
			lyric->addr_tbl[lyric->indexsize]=(uint16_t)(lrcoffset-strtemplen+10); 
			lyric->length_tbl[lyric->indexsize]=strtemplen-10;
			lyric->indexsize++;
		}		
//		else
//				continue;		
	}
}



void MUSIC_I2S_DMA_TX_Callback(void)
{
	if(I2Sx_TX_DMA_STREAM->CR&(1<<19)) //ǰȡMemory1
	{
		bufflag_Music=0;
	}
	else
	{
		bufflag_Music=1;
	}
	Isread_Music=1;
}

/**
  * @brief   WAVʽƵ
	* @note   
  * @param  
  * @retval 
  */
void wavplayer(const char *wavfile,WM_HWIN hWin)
{
	WavHead wav;
  DWORD pos;
  static uint8_t timecount;
  uint16_t curtime,alltime;
  char timestr[6]={0};
  static uint8_t lyriccount=0;

	f_result=f_open(&f_file,wavfile,FA_READ);
	if(f_result!=FR_OK)
	{
		printf("Open wavfile fail!!!->%d\r\n",f_result);
		f_result = f_close (&f_file);
		return;
	}
	f_result = f_read(&f_file,&wav,sizeof(WavHead),&f_num);//ȡWAVļͷ
  
  /* ʼȫֱ */
	Music.ucFreq =  wav.dwSamplesPerSec;
	Music.ucbps =  Music.ucFreq*32;
  
  alltime=f_file.fsize*8/Music.ucbps;
  sprintf(timestr,"%02d:%02d",alltime/60,alltime%60);
  TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT5),timestr);
  
  SLIDER_SetValue(WM_GetDialogItem(hWin, GUI_ID_SLIDER0),0);
  TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT0),"");
  TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT1),UTF8_LYRIC);
  TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT2),"");
  TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT4),"00:00");   

  GUI_Delay(50);
	wm8978_Reset();		/* λWM8978λ״̬ */		
  GUI_Delay(50);
  
	Music.ucStatus = STA_PLAYING;		/* ״̬ */

	/* WM8978оƬΪDACΪ */
	wm8978_CfgAudioPath(DAC_ON, EAR_LEFT_ON | EAR_RIGHT_ON);

	/* ͬ */
	wm8978_SetOUT1Volume(Music.ucVolume);

	/* WM8978ƵӿΪֱ׼I2Sӿڣ16bit */
	wm8978_CfgAudioIF(I2S_Standard_Phillips, 16);
	
	I2S_GPIO_Config();
	I2Sx_Mode_Config(I2S_Standard_Phillips,I2S_DataFormat_16b,Music.ucFreq);
	I2S_DMA_TX_Callback=MUSIC_I2S_DMA_TX_Callback;			//صָwav_i2s_dma_callback
	I2S_Play_Stop();
	
	f_result = f_read(&f_file,buffer_Music[0],BUFFER_SIZE*2,&f_num);
	f_result = f_read(&f_file,buffer_Music[1],BUFFER_SIZE*2,&f_num);
	
	I2Sx_TX_DMA_Init(buffer_Music[0],buffer_Music[1],BUFFER_SIZE);
	Isread_Music=0;
	bufflag_Music=0;
	chgsch=0;
  lyriccount=0;
  timecount=0;
  
	I2S_Play_Start();
	/* ѭ */
	while((Music.ucStatus==STA_PLAYING)||(Music.ucStatus==STA_STOP))
	{
		while(Isread_Music==0)
		{
      if(chgsch==0) 
      { 
        if(timecount>=10)      
        { 
          curtime=f_file.fptr*8/Music.ucbps;                                        //ȡǰŽ(λs)
          sprintf(timestr,"%02d:%02d",curtime/60,curtime%60);
          TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT4),timestr);                  //ʱʾ 
          SLIDER_SetValue(WM_GetDialogItem(hWin, GUI_ID_SLIDER0),curtime*255/alltime); //ʱ    

          lrc->curtime = curtime;
          if((lrc->oldtime <= lrc->curtime*100)&&(lrc->indexsize>10))
          {
            TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT1),(const char *)&comdata[lrc->addr_tbl[lyriccount]-1]);
            if(lyriccount>0)
            {
              TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT0),(const char *)&comdata[lrc->addr_tbl[lyriccount-1]-1]);
            }
            else
              TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT0),"");
            
            if(lyriccount < lrc->indexsize-1)
            {
              TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT2),(const char *)&comdata[lrc->addr_tbl[lyriccount+1]-1]);
            }
            else
              TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT2),"");
            
            do{
              lyriccount++;					
              if(lyriccount>=lrc->indexsize)
              {
                lrc->oldtime=0xffffff;
                break;
              }
              lrc->oldtime=lrc->time_tbl[lyriccount];
            }while(lrc->oldtime<=(lrc->curtime*100));
          }
          
          timecount=0;
        }
      }
      else
      {
        uint8_t temp=0;
        temp=SLIDER_GetValue(WM_GetDialogItem(hWin, GUI_ID_SLIDER0));
        pos=f_file.fsize/255*temp;
        if(pos<sizeof(WavHead))pos=sizeof(WavHead);
        if(wav.wBitsPerSample==24)temp=12;
        else temp=8;
        if((pos-sizeof(WavHead))%temp)
        {
          pos+=temp-(pos-sizeof(WavHead))%temp;
        }        
        f_lseek(&f_file,pos);
        lrc->oldtime=0;
        lyriccount=0;
        chgsch=0;
      }
      if(tpad_flag)WM_DeleteWindow(hWin);
      GUI_Delay(1);
		}
    timecount++;
		if(bufflag_Music==0)
		{
			f_result = f_read(&f_file,buffer_Music[0],BUFFER_SIZE*2,&f_num);	
		}
		else
		{
			f_result = f_read(&f_file,buffer_Music[1],BUFFER_SIZE*2,&f_num);
		}
//		printf("read data:bufflag->%d\n",bufflag);
		Isread_Music=0;
		if((f_result!=FR_OK)||(f_file.fptr==f_file.fsize))
		{
      
			I2S_Play_Stop();
      SLIDER_SetValue(WM_GetDialogItem(hWin, GUI_ID_SLIDER0),0);
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT0),"");
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT1),UTF8_LYRIC);
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT2),"");
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT4),"00:00");
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT5),"00:00"); 
      
			printf("߶ȡ˳...\r\n");
      if(play_index<file_num-1)
				play_index++;
			else
				play_index = 0;
      Music.ucStatus = STA_SWITCH;
			f_result=FR_OK;
			f_file.fptr=0;
			f_close(&f_file);
			I2S_Stop();		/* ֹͣI2S¼ͷ */
			wm8978_Reset();	/* λWM8978λ״̬ */
			return;
		}		
	}
}
/**
  * @brief   WAVʽƵ
	* @note   
  * @param  
  * @retval 
  */
void mp3player(const char *mp3file,WM_HWIN hWin)
{
  DWORD pos;
  static uint8_t timecount;
  uint16_t curtime,alltime;
  char timestr[6]={0};
  static uint8_t lyriccount=0;
	int	read_offset = 0;				/* ƫָ */
	int	bytes_left = 0;					/* ʣֽ */	
  uint8_t *read_ptr;
  uint32_t frames=0;
	int err=0, i=0, outputSamps=0;	
  
	f_result=f_open(&f_file,mp3file,FA_READ);
	if(f_result!=FR_OK)
	{
		printf("Open mp3file fail!!!->%d\r\n",f_result);
		f_result = f_close (&f_file);
		return;
	}

	//ʼMP3
	Mp3Decoder = MP3InitDecoder();	
	if(Mp3Decoder==0)
	{
		printf("ʼhelix豸\n");
		return;	/* ֹͣ */
	}

  TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT5),"00:00");  
  TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT4),"00:00");  
  SLIDER_SetValue(WM_GetDialogItem(hWin, GUI_ID_SLIDER0),0);
  
  TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT0),"");
  TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT1),UTF8_LYRIC);
  TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT2),""); 
   
  
  GUI_Delay(50);  
	wm8978_Reset();		/* λWM8978λ״̬ */		
  GUI_Delay(50);
	Music.ucStatus = STA_PLAYING;		/* ״̬ */
  Music.ucFreq=I2S_AudioFreq_Default;

	/* WM8978оƬΪDACΪ */
	wm8978_CfgAudioPath(DAC_ON, EAR_LEFT_ON | EAR_RIGHT_ON);

	/* ͬ */
	wm8978_SetOUT1Volume(Music.ucVolume);

	/* WM8978ƵӿΪֱ׼I2Sӿڣ16bit */
	wm8978_CfgAudioIF(I2S_Standard_Phillips, 16);
	
	I2S_GPIO_Config();
	I2Sx_Mode_Config(I2S_Standard_Phillips,I2S_DataFormat_16b,Music.ucFreq);
	I2S_DMA_TX_Callback=MUSIC_I2S_DMA_TX_Callback;			//صָwav_i2s_dma_callback
	I2Sx_TX_DMA_Init(buffer_Music[0],buffer_Music[1],MP3BUFFER_SIZE);
  I2S_Play_Stop();
  
	Isread_Music=0;
	bufflag_Music=0;
	chgsch=0;
  lyriccount=0;
  timecount=0;
  
	f_result=f_read(&f_file,inputbuf,INPUTBUF_SIZE,&f_num);
	if(f_result!=FR_OK)
	{
		printf("ȡ%sʧ -> %d\r\n",mp3file,f_result);
		MP3FreeDecoder(Mp3Decoder);
		return;
	}
  read_ptr=inputbuf;
  
	/* ѭ */
	while((Music.ucStatus==STA_PLAYING)||(Music.ucStatus==STA_STOP))
	{
    read_offset = MP3FindSyncWord(read_ptr, bytes_left);
    if(read_offset < 0)																		//ûҵͬ
		{
			f_result=f_read(&f_file,inputbuf,INPUTBUF_SIZE,&f_num);
			if(f_result!=FR_OK)
			{
				printf("ȡ%sʧ -> %d\r\n",mp3file,f_result);
				break;
			}
			read_ptr=inputbuf;
			bytes_left=f_num;
			continue;																						
		}
		read_ptr += read_offset;					//ƫֵͬλ
		bytes_left -= read_offset;				//֮ͬݴС	
		if(bytes_left < 1024)							//
		{
      
			/* עطΪõDMAȡһҪ4ֽڶ  */
			i=(uint32_t)(bytes_left)&3;									//ж϶ֽ
			if(i) i=4-i;														//Ҫֽ
			memcpy(inputbuf+i, read_ptr, bytes_left);	//Ӷλÿʼ
			read_ptr = inputbuf+i;										//ָݶλ
			f_result = f_read(&f_file, inputbuf+bytes_left+i, INPUTBUF_SIZE-bytes_left-i, &f_num);//
			bytes_left += f_num;										//ЧС
		}
		err = MP3Decode(Mp3Decoder, &read_ptr, &bytes_left, (short *)buffer_Music[bufflag_Music], 0);					//ʼ mp3ṹ塢ָ롢Сָ롢ݸʽ
		frames++;	
    if (err != ERR_MP3_NONE)									//
		{
			switch (err)
			{
				case ERR_MP3_INDATA_UNDERFLOW:
					printf("ERR_MP3_INDATA_UNDERFLOW\r\n");
					f_result = f_read(&f_file, inputbuf, INPUTBUF_SIZE, &f_num);
					read_ptr = inputbuf;
					bytes_left = f_num;
					break;		
				case ERR_MP3_MAINDATA_UNDERFLOW:
					/* do nothing - next call to decode will provide more mainData */
					printf("ERR_MP3_MAINDATA_UNDERFLOW\r\n");
					break;		
				default:
					printf("UNKNOWN ERROR:%d\r\n", err);		
					// ֡
					if (bytes_left > 0)
					{
						bytes_left --;
						read_ptr ++;
					}	
					break;
			}
			Isread_Music=1;
		}
    else		//޴׼PCM
		{
			MP3GetLastFrameInfo(Mp3Decoder, &Mp3FrameInfo);		//ȡϢ				
			/* DAC */
			outputSamps = Mp3FrameInfo.outputSamps;							//PCMݸ
			if (outputSamps > 0)
			{
				if (Mp3FrameInfo.nChans == 1)	//
				{
					//Ҫһݵһ
					for (i = outputSamps - 1; i >= 0; i--)
					{
						buffer_Music[bufflag_Music][i * 2] = buffer_Music[bufflag_Music][i];
						buffer_Music[bufflag_Music][i * 2 + 1] = buffer_Music[bufflag_Music][i];
					}
					outputSamps *= 2;
				}//if (Mp3FrameInfo.nChans == 1)	//
			}//if (outputSamps > 0)
			
			/* ݽϢò */
			if (Mp3FrameInfo.samprate != Music.ucFreq)	// 
			{
				Music.ucFreq = Mp3FrameInfo.samprate;
				Music.ucbps=Mp3FrameInfo.bitrate;        //ʣmp3һΪ320Kbps
        alltime=f_file.fsize*8/Music.ucbps;         
        //f_file.fsizeΪļС磺Ź-֮ ׸Ϊ11 495 969ֽڣܹ11495969*8λ
        //Ϊ320kbps320000bps
        //ܵĲʱ䣺alltime=f_file.fsize*8/Music.uckbps=11495969*8/320000=287.399225롣
        sprintf(timestr,"%02d:%02d",alltime/60,alltime%60);
        TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT5),timestr);
        
				printf(" \r\n Bitrate       %dKbps", Mp3FrameInfo.bitrate/1000);
				printf(" \r\n Samprate      %dHz", Music.ucFreq);
				printf(" \r\n BitsPerSample %db", Mp3FrameInfo.bitsPerSample);
				printf(" \r\n nChans        %d", Mp3FrameInfo.nChans);
				printf(" \r\n Layer         %d", Mp3FrameInfo.layer);
				printf(" \r\n Version       %d", Mp3FrameInfo.version);
				printf(" \r\n OutputSamps   %d", Mp3FrameInfo.outputSamps);
				printf("\r\n");
				if(Music.ucFreq >= I2S_AudioFreq_Default)	//I2S_AudioFreq_Default = 2֡ÿζҪ
				{
					I2Sx_Mode_Config(I2S_Standard_Phillips,I2S_DataFormat_16b,Music.ucFreq);						//ݲ޸iis
					I2Sx_TX_DMA_Init(buffer_Music[0],buffer_Music[1],outputSamps);//MP3BUFFER_SIZE);
				}
				I2S_Play_Start();
			}
		}//else 
    
		while(Isread_Music==0)
		{
      if(chgsch==0) 
      { 
        if(timecount>=20)      
        { 
          curtime=f_file.fptr*8/Music.ucbps;                                        //ȡǰŽ(λs)
          sprintf(timestr,"%02d:%02d",curtime/60,curtime%60);
          TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT4),timestr);                  //ʱʾ 
          SLIDER_SetValue(WM_GetDialogItem(hWin, GUI_ID_SLIDER0),curtime*255/alltime); //ʱ    

          lrc->curtime = curtime;          
          if((lrc->oldtime <= lrc->curtime*100)&&(lrc->indexsize>10))
          {
            TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT1),(const char *)&comdata[lrc->addr_tbl[lyriccount]-1]);
            if(lyriccount>0)
            {
              TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT0),(const char *)&comdata[lrc->addr_tbl[lyriccount-1]-1]);
            }
            else
              TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT0),"");
            
            if(lyriccount < lrc->indexsize-1)
            {
              TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT2),(const char *)&comdata[lrc->addr_tbl[lyriccount+1]-1]);
            }
            else
              TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT2),"");
            
            do{
              lyriccount++;					
              if(lyriccount>=lrc->indexsize)
              {
                lrc->oldtime=0xffffff;
                break;
              }
              lrc->oldtime=lrc->time_tbl[lyriccount];
            }while(lrc->oldtime<=(lrc->curtime*100));
          }
          
          timecount=0;
        }
      }
      else
      {
        uint8_t temp=0;
        temp=SLIDER_GetValue(WM_GetDialogItem(hWin, GUI_ID_SLIDER0));
        pos=f_file.fsize/255*temp;        
        f_lseek(&f_file,pos);
        lrc->oldtime=0;
        lyriccount=0;
        chgsch=0;
      }
      if(tpad_flag)WM_DeleteWindow(hWin);
      GUI_Delay(1);
		}
    timecount++;		
		Isread_Music=0;
    
		if((f_result!=FR_OK)||(f_file.fptr==f_file.fsize))
		{
      MP3FreeDecoder(Mp3Decoder);
			I2S_Play_Stop();
      SLIDER_SetValue(WM_GetDialogItem(hWin, GUI_ID_SLIDER0),0);
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT0),"");
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT1),UTF8_LYRIC);
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT2),"");
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT4),"00:00");
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT5),"00:00"); 
      
			printf("߶ȡ˳...\r\n");
      if(play_index<file_num-1)
				play_index++;
			else
				play_index = 0;
      Music.ucStatus = STA_SWITCH;
			f_result=FR_OK;
			f_file.fptr=0;
			f_close(&f_file);
			I2S_Stop();		/* ֹͣI2S¼ͷ */
			wm8978_Reset();	/* λWM8978λ״̬ */
			return;
		}		
	}
}

// USER END

/*********************************************************************
*
*       _cbDialog
*/
static void _cbDialogMusic(WM_MESSAGE * pMsg) {
  WM_HWIN hItem;
  int     NCode;
  int     Id;
  // USER START (Optionally insert additional variables)
  uint8_t i=0,j=0,k=0;
  char music_name[FILE_NAME_LEN];
	uint16_t UCname[30]={0},gbkdata=0;
  char tmp[4];  
  // USER END

  switch (pMsg->MsgId) {
   case WM_DELETE:
		// USER START (Optionally insert additional code for further widget initialization)   
		OS_INFO("MusicDLG delete\n");		
		Flag_ICON1 = 0;
		UserApp_Flag = 0;
    tpad_flag=0;
    Music.ucStatus = STA_IDLE;		/* ״̬ */
   	I2S_Stop();		/* ֹͣI2S¼ͷ */
		wm8978_Reset();	/* λWM8978λ״̬ */
    buffer_Music[0]=NULL;
    buffer_Music[1]=NULL;
    pMEM_Music=NULL;
    GUI_ALLOC_Free(hMEM_Music);    
		// USER END
	break;
  case WM_INIT_DIALOG:
  //
  // Initialization of 'music'
  //
  hItem = pMsg->hWin;
  FRAMEWIN_SetText(hItem,UTF8_MUSICDLG);
  FRAMEWIN_AddCloseButton(hItem,FRAMEWIN_BUTTON_RIGHT,0);
  //
  // Initialization of 'lyric1'
  //
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_TEXT0);
  TEXT_SetTextAlign(hItem, GUI_TA_HCENTER | GUI_TA_BOTTOM);
  TEXT_SetFont(hItem, &XBF_XINSONGTI19);
  TEXT_SetText(hItem,"");
  //
  // Initialization of 'lyric2'
  //
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_TEXT1);
  TEXT_SetFont(hItem, &XBF_XINSONGTI19);
  TEXT_SetTextAlign(hItem, GUI_TA_HCENTER | GUI_TA_VCENTER);
	TEXT_SetText(hItem,UTF8_LYRIC);
  TEXT_SetTextColor(hItem,GUI_ORANGE);
  //
  // Initialization of 'lyric3'
  //
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_TEXT2);
  TEXT_SetTextAlign(hItem, GUI_TA_HCENTER | GUI_TA_TOP);
  TEXT_SetFont(hItem, &XBF_XINSONGTI19);
	TEXT_SetText(hItem,"");
  //
  // Initialization of 'mucis'
  //
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_TEXT3);
  TEXT_SetTextAlign(hItem, GUI_TA_HCENTER | GUI_TA_VCENTER);
  TEXT_SetFont(hItem, &XBF_XINSONGTI25);
	TEXT_SetText(hItem,UTF8_SONG);
  //
  // Initialization of 'PlayTime'
  //
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_TEXT4);	
  TEXT_SetFont(hItem, GUI_FONT_13_ASCII);
  TEXT_SetTextAlign(hItem, GUI_TA_LEFT | GUI_TA_TOP);
  TEXT_SetText(hItem,"00:00");
  //
  // Initialization of 'AllTime'
  //
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_TEXT5);
  TEXT_SetFont(hItem, GUI_FONT_13_ASCII);
  TEXT_SetTextAlign(hItem, GUI_TA_RIGHT | GUI_TA_TOP);
  TEXT_SetText(hItem,"00:00");
  //
  // Initialization of 'volume'
  //
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_TEXT6);
  TEXT_SetFont(hItem, GUI_FONT_16_ASCII);
  TEXT_SetTextAlign(hItem, GUI_TA_LEFT | GUI_TA_TOP);
  sprintf(tmp,"%2d%%",Music.ucVolume*100/63);
  TEXT_SetText(hItem,tmp);
  //
  // Initialization of 'Schedule'
  //
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_SLIDER0);
  SLIDER_SetRange(hItem,0,0xff);
  SLIDER_SetValue(hItem,0);
  SLIDER_SetWidth(hItem,3);
  SLIDER_SetNumTicks(hItem,0);
  //
  // Initialization of 'Volume'
  //
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_SLIDER1);
  SLIDER_SetRange(hItem,1,63);
  SLIDER_SetValue(hItem,Music.ucVolume);
	//
	// Initialization of 'Play'
	//
	hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON0);
	BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmplay,10,10);
	BUTTON_SetText(hItem,"");
	//
	// Initialization of 'Back'
	//
	hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON1);
	BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmback,10,10);
	BUTTON_SetText(hItem,"");
	//
	// Initialization of 'Next'
	//
	hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON2);
	BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmnext,10,10);
	BUTTON_SetText(hItem,"");	
  //
	// Initialization of 'volume'
	//
	hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON3);
	BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmvolume_medium,0,0);
	BUTTON_SetText(hItem,"");
  //
  // Initialization of 'musiclist'
  //
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_LISTBOX0);
  LISTBOX_SetMulti(hItem,0);
	LISTBOX_SetFont(hItem, &XBF_XINSONGTI19);
	LISTBOX_SetAutoScrollV(hItem,1);       
  LISTBOX_SetItemSpacing(hItem,5);	
  LISTBOX_SetTextAlign(hItem,GUI_TA_LEFT|GUI_TA_VCENTER);
#if   LCD_NUM_LAYERS == 2
  LISTBOX_SetBkColor(hItem,LISTBOX_CI_UNSEL,GUI_TRANSPARENT);
  LISTBOX_SetBkColor(hItem,LISTBOX_CI_SEL,GUI_GRAY);
  LISTBOX_SetBkColor(hItem,LISTBOX_CI_SELFOCUS,GUI_GRAY);
  LISTBOX_SetBkColor(hItem,LISTBOX_CI_DISABLED,GUI_TRANSPARENT);
#endif
  // USER START (Optionally insert additional code for further widget initialization)
  file_num=0;
  for(i=0;i<MUSIC_MAX_NUM;i++)
  {
    for(j=0;j<FILE_NAME_LEN;j++)
      playlist[i][j]=0;
    for(j=0;j<MUSIC_NAME_LEN;j++)
      lcdlist[i][j]=0;
  }
  scan_files(path);
  hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_LISTBOX0);
  if(file_num)
	{
    for(i=0;i<file_num;i++)
    {
      for(j=0,k=0;(j<51)&&lcdlist[i][j]!='\0';k++)
      {
        if(lcdlist[i][j]>0x80)
        {
          gbkdata=lcdlist[i][j+1]+lcdlist[i][j]*256;
          UCname[k]=ff_convert(gbkdata,1);
          //printf("%d:%04X\n",j,UCname[k]);
          j+=2;
        }
        else
        {
          UCname[k]=0x00ff&lcdlist[i][j];
          //printf("%d:%04X\n",j,UCname[k]);
          j+=1;
        }
      }
      UCname[k]='\0';
      //printf("%d.%s\n",i+1,lcdlist[i]);			
      GUI_UC_ConvertUC2UTF8(UCname,MUSIC_NAME_LEN,music_name,FILE_NAME_LEN);
      LISTBOX_AddString(hItem,music_name);
    }
  }
  else
  {
    LISTBOX_AddString(hItem,"no music file");
    LISTBOX_SetSel(hItem,-1);
  }
  
    // USER END
  break;
  case WM_NOTIFY_PARENT:
    Id    = WM_GetId(pMsg->hWinSrc);
    NCode = pMsg->Data.v;
    switch(Id) {
    case GUI_ID_LISTBOX0: // Notifications sent by 'musiclist'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON0);
				if(Music.ucStatus == STA_IDLE)
				{
					Music.ucStatus = STA_PLAYING;
					BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmstop,10,10);
				}
				else
					Music.ucStatus = STA_SWITCH;
					play_index=LISTBOX_GetSel(WM_GetDialogItem(pMsg->hWin, GUI_ID_LISTBOX0));
        // USER END
        break;
      case WM_NOTIFICATION_SEL_CHANGED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case GUI_ID_SLIDER0: // Notifications sent by 'schedule'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_SLIDER0);
        chgsch=1;
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)        
        // USER END
        break;
      case WM_NOTIFICATION_VALUE_CHANGED:
        // USER START (Optionally insert code for reacting on notification message)        
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case GUI_ID_BUTTON0: // Notifications sent by 'play'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON0);
		    if(Music.ucStatus != STA_PLAYING)
		    {
			    BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmstop,10,10);
			    Music.ucStatus = STA_PLAYING;
          I2S_Play_Start();
		    }
		    else if(Music.ucStatus == STA_PLAYING)
		    {
		    	BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmplay,10,10);
		    	Music.ucStatus = STA_STOP;
          I2S_Play_Stop();
		    }
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case GUI_ID_SLIDER1: // Notifications sent by 'volume'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)       
        // USER END
        break;
      case WM_NOTIFICATION_VALUE_CHANGED:
        // USER START (Optionally insert code for reacting on notification message)
        hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_SLIDER1);
		    Music.ucVolume = SLIDER_GetValue(hItem);
        sprintf(tmp,"%2d%%",Music.ucVolume*100/63);
        TEXT_SetText(WM_GetDialogItem(pMsg->hWin, GUI_ID_TEXT6),tmp);

        hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON3);
        if(Music.ucVolume==1)
        {
          wm8978_OutMute(1);
          Music.ucMute=1;
          BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmvolume_mute,0,0);
        }
        else
        {
          wm8978_OutMute(0);
          Music.ucMute=0;
          BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmvolume_medium,0,0);
          /* ͬ */
          wm8978_SetOUT1Volume(Music.ucVolume);
        }
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case GUI_ID_BUTTON1: // Notifications sent by 'back'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_LISTBOX0);
        if(Music.ucStatus != STA_IDLE) 
        {
          Music.ucStatus = STA_SWITCH;
        }
        play_index--;
        if(play_index>file_num)play_index=file_num-1;
        LISTBOX_SetSel(hItem,play_index);
        //printf("paly_index=%d\n",play_index);
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case GUI_ID_BUTTON2: // Notifications sent by 'next'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_LISTBOX0);
        if(Music.ucStatus != STA_IDLE) 
        {
          Music.ucStatus = STA_SWITCH;
        }
        play_index++;
        if(play_index>=file_num)play_index=0;
        LISTBOX_SetSel(hItem,play_index);
        //printf("paly_index=%d\n",play_index);      
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case GUI_ID_BUTTON3: // Notifications sent by 'volume'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        hItem = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON3);
		    if(Music.ucMute==0)
		    {
			    BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmvolume_mute,0,0);
          Music.ucMute=1;
		    }
		    else
		    {          
		    	BUTTON_SetBitmapEx(hItem,BUTTON_BI_UNPRESSED,&bmvolume_medium,0,0);
          Music.ucMute=0;
		    }
        wm8978_OutMute(Music.ucMute);
        //printf("paly_index=%d\n",play_index);      
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    // USER START (Optionally insert additional code for further Ids)
    // USER END
    }
    break;
  // USER START (Optionally insert additional message handling)
  case WM_PAINT:		
#if   LCD_NUM_LAYERS == 1 
		GUI_SetBkColor(APPBKCOLOR);
#elif LCD_NUM_LAYERS == 2
     GUI_SetBkColor(GUI_TRANSPARENT);
#endif
		 GUI_Clear();
		break;
  // USER END
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}



/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       Createmusic
*/
void FUN_ICON1Clicked(void) 
{
  uint16_t i=0;
  WM_HWIN hWin;
  char str[MUSIC_NAME_LEN]={0};
  char music_name[FILE_NAME_LEN]={0};
	char name_showlcd[MUSIC_NAME_LEN]={0};
  OS_INFO("MusicDLG create\n");
  Music.ucVolume = 35;		/* ȱʡ */
  Music.ucMute=0;
    
	/* ļϵͳ -- SD */
  WIFI_PDN_DISABLE();
  f_result = f_mount(&fs[0],"0:",1);	/* Mount a logical drive */
	if(f_result!=FR_OK)
    bsp_result |= BSP_SD;
  else 
    bsp_result &=~BSP_SD;
    
  /* WM8978оƬ˺ԶCPUGPIO */
  if (wm8978_Init()==0)
    bsp_result|=BSP_WM8978;
  else
    bsp_result&=~BSP_WM8978;  
  
  hWin = GUI_CreateDialogBox(_aDialogCreateMusic, GUI_COUNTOF(_aDialogCreateMusic), _cbDialogMusic, HDTWIN, 0, 0);
  
  /* һڴռ ҽ */
  hMEM_Music = GUI_ALLOC_AllocZero(BUFFER_SIZE*5+sizeof(LYRIC));

  /* 뵽ڴľתָ */
  pMEM_Music = GUI_ALLOC_h2p(hMEM_Music);
  if(pMEM_Music==NULL)
  {
    bsp_result|=BSP_ALLOC;
    buffer_Music[0]=NULL;
    buffer_Music[1]=NULL;
    
  }
  else
  {
    buffer_Music[0]=(uint16_t *)pMEM_Music;
    buffer_Music[1]=(uint16_t *)(pMEM_Music+BUFFER_SIZE*2);
    lrc=(LYRIC *)(pMEM_Music+BUFFER_SIZE*5);
    bsp_result&=~BSP_ALLOC;
  }
  
  Music.ucStatus = STA_IDLE;		/* ״̬ */	
  
  if((bsp_result&BSP_SD)||(bsp_result&BSP_WM8978))
  {		
    GUI_Delay(100);
    if(bsp_result&BSP_WM8978)
      sprintf(str,"The WM8978 drive cannot work!");  
    else if(bsp_result&BSP_SD)
      sprintf(str,UTF8_SDCARDERROR); 
    else
      sprintf(str,"one drive cannot work!");
    ErrorDialog(hWin,"Music Error",str);
    while(1)
    {
       if(tpad_flag)WM_DeleteWindow(hWin);
       if(!Flag_ICON1)return;
       GUI_Delay(10);
    }
  }
  
  while(Flag_ICON1)
  {
    if(Music.ucStatus==STA_PLAYING)
		{      
      LISTBOX_SetSel(WM_GetDialogItem(hWin, GUI_ID_LISTBOX0),play_index);
      i=0;
      while(lcdlist[play_index][i]!='\0')
      {
        name_showlcd[i]=lcdlist[play_index][i];
        i++;
      }
      name_showlcd[i]='\0';				
      com_gbk2utf8(name_showlcd,str);
      TEXT_SetText(WM_GetDialogItem(hWin, GUI_ID_TEXT3),str);
      i=0;
      while(playlist[play_index][i]!='\0')
      {
        music_name[i]=playlist[play_index][i];
        i++;
      }				
      music_name[i]='\0';
      lrc_chg_suffix((uint8_t *)music_name,"lrc");
      com_data2null(comdata,COMDATA_SIZE);
      i=0;
      while(i<LYRIC_MAX_SIZE)
      {
        lrc->addr_tbl[i]=0;
        lrc->length_tbl[i]=0;
        lrc->time_tbl[i]=0;
        i++;
      }
      lrc->indexsize=0;
			lrc->oldtime=0;
			lrc->curtime=0;
      f_result=f_open(&f_file,music_name,FA_READ);
      if((f_result==FR_OK)&&(f_file.fsize<COMDATA_SIZE))
      {					
        f_result=f_read(&f_file,comdata,f_file.fsize,&f_num);		
        if(f_result==FR_OK) 
        {
          OS_ERR      err;
          OSSchedLock(&err);
          lyric_analyze(lrc,comdata);
          lrc_sequence(lrc);
          OSSchedUnlock(&err);            
        }
      }
			f_close(&f_file);	      
      i=0;
			while(playlist[play_index][i]!='\0')
			{
				music_name[i]=playlist[play_index][i];
				i++;
			}
			music_name[i]='\0';
      if(strstr(music_name,".wav")||strstr(music_name,".WAV"))
      {
        buffer_Music[0]=(uint16_t *)pMEM_Music;
        buffer_Music[1]=(uint16_t *)(pMEM_Music+BUFFER_SIZE*2);
        lrc=(LYRIC *)(pMEM_Music+BUFFER_SIZE*5);
        wavplayer(music_name,hWin);
      }
      else
      {
        buffer_Music[0]=(uint16_t *)pMEM_Music;
        buffer_Music[1]=(uint16_t *)(pMEM_Music+BUFFER_SIZE);
        inputbuf=(uint8_t *)(pMEM_Music+BUFFER_SIZE*2);
        lrc=(LYRIC *)(pMEM_Music+BUFFER_SIZE*5);
        mp3player(music_name,hWin);
      }
    }
    else if(Music.ucStatus==STA_SWITCH)
    {	
      GUI_Delay(100);
      Music.ucStatus = STA_PLAYING;
      BUTTON_SetBitmapEx(WM_GetDialogItem(hWin, GUI_ID_BUTTON0),BUTTON_BI_UNPRESSED,&bmstop,10,10);
    }
    if(tpad_flag)WM_DeleteWindow(hWin);
    GUI_Delay(10);
  }
}

// USER START (Optionally insert additional public code)
// USER END

/*************************** End of file ****************************/
