/**
  ******************************************************************************
  * @file    bsp_touchpad.c
  * @author  fire
  * @version V1.0
  * @date    2015-xx-xx
  * @brief   ݰӦúӿ
  ******************************************************************************
  * @attention
  *
  * ʵƽ̨:  STM32 F429   
  * ̳    :http://www.firebbs.cn
  * Ա    :http://firestm32.taobao.com
  *
  ******************************************************************************
  */
#include "./Bsp/TouchPad/bsp_touchpad.h"
#include "./Bsp/usart/bsp_debug_usart.h"
#include  "./Bsp/bsp.h"

#define TPAD_ARR_MAX_VAL 	0XFFFFFFFF	//ʱֵ

volatile uint32_t tpad_default_val=0;//ûʱʱֵ

static void TPAD_Reset(void);
static uint16_t  TPAD_Get_Val(void);
static uint16_t  TPAD_Get_MaxVal(uint8_t n);
static void TIMx_CHx_Cap_Init(uint32_t arr,uint16_t psc); 


/********************************************************
*
* ʼ
* ÿصʱȡֵ.
* ֵ:0,ʼɹ;1,ʼʧ
*
*********************************************************/
uint8_t TPAD_Init(void)
{
	uint16_t buf[10];
	uint16_t temp;
	uint8_t j,i;
	TIMx_CHx_Cap_Init(TPAD_ARR_MAX_VAL,20-1);//20=180M/9M180MΪϵͳʱӣ9MΪĿʱ
	for(i=0;i<10;i++)//ȡ10
	{				 
		buf[i]=TPAD_Get_Val();
		bsp_DelayMS(10);	    
	}				    
	for(i=0;i<9;i++)//
	{
		for(j=i+1;j<10;j++)
		{
			if(buf[i]>buf[j])//
			{
				temp=buf[i];
				buf[i]=buf[j];
				buf[j]=temp;
			}
		}
	}
	temp=0;
	for(i=2;i<8;i++)temp+=buf[i];//ȡм8ݽƽ
	tpad_default_val=temp/6;
	//printf("tpad_default_val:%d\r\n",tpad_default_val);	
	if(tpad_default_val>TPAD_ARR_MAX_VAL/2)return 1;//ʼTPAD_ARR_MAX_VAL/2ֵ,!
	return 0;		     	    					   
}

/****************************************
*
* Ϊݰŵ
* ʱ־
*
*****************************************/
static void TPAD_Reset(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure; 
	
 	GPIO_InitStructure.GPIO_Pin = TPAD_TIM_CH_PIN;				 //˿
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ͨ
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;	//ٶ100MHz
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; // 
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN; //
 	GPIO_Init(TPAD_TIM_CH_PORT, &GPIO_InitStructure);
	
 	GPIO_ResetBits ( TPAD_TIM_CH_PORT, TPAD_TIM_CH_PIN );						 //PA.10,ŵ

	bsp_DelayMS(5);

	
	TIM_ClearITPendingBit(TPAD_TIMx, TPAD_TIM_IT_CCx|TIM_IT_Update); //жϱ־
	TIM_SetCounter(TPAD_TIMx,0);		//0
	
	GPIO_InitStructure.GPIO_Pin = TPAD_TIM_CH_PIN; //PA1 ˿
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;//
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;//ٶ100MHz
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; // 
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;// 
	GPIO_Init(TPAD_TIM_CH_PORT,&GPIO_InitStructure); //ʼPA5 

}

/****************************************************
*
* õʱֵ
* ʱ,ֱӷضʱļֵ.
*
*****************************************************/
static uint16_t TPAD_Get_Val(void)
{				   
	TPAD_Reset();
	while(TIM_GetFlagStatus ( TPAD_TIMx, TPAD_TIM_IT_CCx ) == RESET)//ȴ
	{
		if(TIM_GetCounter(TPAD_TIMx)>TPAD_ARR_MAX_VAL-500)return TIM_GetCounter(TPAD_TIMx);//ʱ,ֱӷCNTֵ
	};	
	return TPAD_TIM_GetCaptureX(TPAD_TIMx );	  
} 	 

/****************************************************
*
* ȡn,ȡֵ
* nȡĴ
* ֵnζֵ
*
*****************************************************/
static uint16_t TPAD_Get_MaxVal(uint8_t n)
{
	uint16_t temp=0;
	uint16_t res=0;
	while(n--)
	{
		temp=TPAD_Get_Val();//õһֵ
		if(temp>res)res=temp;
	};
	return res;
}  

/*******************************************************************************
*
* ɨ败
* mode:0,֧(һαɿܰһ);1,֧(һֱ)
* ֵ:0,ûа;1,а;			
*
*******************************************************************************/
#define TPAD_GATE_VAL 	100	//ֵ,ҲǱtpad_default_val+TPAD_GATE_VAL,ΪЧ.
uint8_t TPAD_Scan(uint8_t mode)
{
	static uint8_t keyen=0;	//0,Կʼ;>0,ܿʼ	 
	uint8_t res=0;
	uint8_t sample=3;		//ĬϲΪ3	 
	uint16_t rval;
	if(mode)
	{
		sample=6;	//֧ʱòΪ6
		keyen=0;	//֧	  
	}
	rval=TPAD_Get_MaxVal(sample); 
//	printf("scan_rval=%d\n",rval);
	if(rval>(tpad_default_val+TPAD_GATE_VAL)&&rval<(10*tpad_default_val))//tpad_default_val+TPAD_GATE_VAL,С10tpad_default_val,Ч
	{						
		if(keyen==0)res=1;	//keyen==0,Ч 
		//printf("rval:%d\r\n",rval);		     	    					   
		keyen=3;				//Ҫٹ3֮ܰЧ   
	} 
	if(keyen)keyen--;		   							   		     	    					   
	return res;
}	 

/***********************************
*
* ʱ벶
*
***********************************/
static void TIMx_CHx_Cap_Init(uint32_t arr,uint16_t psc)
{
	GPIO_InitTypeDef  GPIO_InitStructure; 
  TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	TIM_ICInitTypeDef  TIM_ICInitStructure;
	
	RCC_APB1PeriphClockCmd(TPAD_TIM_CLK,ENABLE);  	  //TIM2ʱʹ    
	RCC_AHB1PeriphClockCmd(TPAD_TIM_GPIO_CLK, ENABLE); 	//ʹPORTAʱ	
	
	GPIO_PinAFConfig(TPAD_TIM_CH_PORT,TPAD_TIM_SOURCE,TPAD_TIM_AF); //GPIOA1λʱ5
	
	GPIO_InitStructure.GPIO_Pin = TPAD_TIM_CH_PIN;				 //PA1 ˿
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;//ù
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;	//ٶ100MHz
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; //츴
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;// 
	GPIO_Init(TPAD_TIM_CH_PORT, &GPIO_InitStructure);	 //Ϊ
	
	//ʼTIM
	TIM_TimeBaseStructure.TIM_Period = arr; //趨Զװֵ   
	TIM_TimeBaseStructure.TIM_Prescaler =psc; 	//ԤƵ 	   
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //ʱӷָ:TDTS = Tck_tim
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
	TIM_TimeBaseInit(TPAD_TIMx, &TIM_TimeBaseStructure); //TIM_TimeBaseInitStructָĲʼTIMxʱλ
	//ʼͨ
	TIM_ICInitStructure.TIM_Channel = TPAD_TIM_Channel_X; //CC1S=01 	ѡ IC2ӳ䵽TI5
	TIM_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Rising;	//ز
	TIM_ICInitStructure.TIM_ICSelection = TIM_ICSelection_DirectTI; 
	TIM_ICInitStructure.TIM_ICPrescaler = TIM_ICPSC_DIV1;	 //Ƶ,Ƶ 
	TIM_ICInitStructure.TIM_ICFilter = 0x00;//IC2F=0000 ˲ ˲
	TIM_ICInit(TPAD_TIMx, &TIM_ICInitStructure);//ʼI5 IC2

	TIM_Cmd ( TPAD_TIMx, ENABLE ); 	//ʹܶʱ5
		
}


/*********************************************END OF FILE**********************/
