/**
  ******************************************************************************
  * @file    bsp_xxx.c
  * @author  fire
  * @version V1.0
  * @date    2013-xx-xx
  * @brief   adc1 Ӧbsp / DMA ģʽ
  ******************************************************************************
  * @attention
  *
  * ʵƽ̨:  STM32 F429    
  * ̳    :http://www.firebbs.cn
  * Ա    :http://firestm32.taobao.com
  *
  ******************************************************************************
  */ 
  
#include "Bsp/adc/bsp_adc.h"



__IO uint16_t ADC_ConvertedValue;

/**
  * @brief  ADCGPIO
  * @param  
  * @retval 
  */
static void Rheostat_ADC_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	// ʹ GPIO ʱ
	RCC_AHB1PeriphClockCmd(RHEOSTAT_ADC_GPIO_CLK, ENABLE);
		
	//  IO
	GPIO_InitStructure.GPIO_Pin = RHEOSTAT_ADC_GPIO_PIN;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;	    
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL ; //
	GPIO_Init(RHEOSTAT_ADC_GPIO_PORT, &GPIO_InitStructure);			
}

/**
  * @brief  ADCDMA
  * @param  
  * @retval 
  */
static void Rheostat_ADC_Mode_Config(void)
{
	DMA_InitTypeDef DMA_InitStructure;
	ADC_InitTypeDef ADC_InitStructure;
  ADC_CommonInitTypeDef ADC_CommonInitStructure;
	
  // ADCʱ
	RCC_APB2PeriphClockCmd(RHEOSTAT_ADC_CLK , ENABLE);
	
	// ------------------DMA Init ṹ ʼ--------------------------
  // ADC1ʹDMA20ͨ0̶ֲ
  // DMAʱ
  RCC_AHB1PeriphClockCmd(RHEOSTAT_ADC_DMA_CLK, ENABLE); 
	// ַΪADC ݼĴַ
	DMA_InitStructure.DMA_PeripheralBaseAddr = RHEOSTAT_ADC_DR_ADDR;	
  // 洢ַʵϾһڲSRAMı	
	DMA_InitStructure.DMA_Memory0BaseAddr = (u32)&ADC_ConvertedValue;  
  // ݴ䷽Ϊ赽洢	
	DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralToMemory;	
	// СΪ1ĴСӦõڴ洢ĴС
	DMA_InitStructure.DMA_BufferSize = 1;	
	// Ĵֻһַõ
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  // 洢̶ַ
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Disable; 
  // // ݴСΪֽ֣ 
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord; 
  //	洢ݴСҲΪ֣ݴСͬ
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;	
	// ѭģʽ
	DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
  // DMA ͨȼΪߣʹһDMAͨʱȼòӰ
	DMA_InitStructure.DMA_Priority = DMA_Priority_High;
  // ֹDMA FIFO	ʹֱģʽ
  DMA_InitStructure.DMA_FIFOMode = DMA_FIFOMode_Disable;  
  // FIFO СFIFOģʽֹʱ	
  DMA_InitStructure.DMA_FIFOThreshold = DMA_FIFOThreshold_HalfFull;
  DMA_InitStructure.DMA_MemoryBurst = DMA_MemoryBurst_Single;
  DMA_InitStructure.DMA_PeripheralBurst = DMA_PeripheralBurst_Single;  
	// ѡ DMA ͨͨ
  DMA_InitStructure.DMA_Channel = RHEOSTAT_ADC_DMA_CHANNEL; 
  //ʼDMA൱һĹܵܵкܶͨ
	DMA_Init(RHEOSTAT_ADC_DMA_STREAM, &DMA_InitStructure);
	// ʹDMA
  DMA_Cmd(RHEOSTAT_ADC_DMA_STREAM, ENABLE);

  // -------------------ADC Common ṹ  ʼ------------------------
	// ADCģʽ
  ADC_CommonInitStructure.ADC_Mode = ADC_Mode_Independent;
  // ʱΪfpclk xƵ	
  ADC_CommonInitStructure.ADC_Prescaler = ADC_Prescaler_Div2;
  // ֹDMAֱӷģʽ	
  ADC_CommonInitStructure.ADC_DMAAccessMode = ADC_DMAAccessMode_Disabled;
  // ʱ	
  ADC_CommonInitStructure.ADC_TwoSamplingDelay = ADC_TwoSamplingDelay_5Cycles;  
  ADC_CommonInit(&ADC_CommonInitStructure);
	
  // -------------------ADC Init ṹ  ʼ--------------------------
  // ADC ֱ
  ADC_InitStructure.ADC_Resolution = ADC_Resolution_12b;
  // ֹɨģʽͨɼҪ	
  ADC_InitStructure.ADC_ScanConvMode = DISABLE; 
  // ת	
  ADC_InitStructure.ADC_ContinuousConvMode = ENABLE; 
  //ֹⲿش
  ADC_InitStructure.ADC_ExternalTrigConvEdge = ADC_ExternalTrigConvEdge_None;
  //ʹⲿãע͵
  //ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_T1_CC1;
  //Ҷ	
  ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
  //תͨ 1
  ADC_InitStructure.ADC_NbrOfConversion = 1;                                    
  ADC_Init(RHEOSTAT_ADC, &ADC_InitStructure);
  //---------------------------------------------------------------------------
	
  //  ADC ͨת˳Ϊ1һתʱΪ3ʱ
  ADC_RegularChannelConfig(RHEOSTAT_ADC, RHEOSTAT_ADC_CHANNEL, 1, ADC_SampleTime_3Cycles); 
  // ʹDMA after last transfer (Single-ADC mode)
  ADC_DMARequestAfterLastTransferCmd(RHEOSTAT_ADC, ENABLE);
  // ʹADC DMA
  ADC_DMACmd(RHEOSTAT_ADC, ENABLE);
  // ʹADC
  ADC_Cmd(RHEOSTAT_ADC, ENABLE);  
  //ʼadcת
  ADC_SoftwareStartConv(RHEOSTAT_ADC);
}

/**
  * @brief  ADC1ʼ
  * @param  
  * @retval 
  */
void Rheostat_Init(void)
{
	Rheostat_ADC_GPIO_Config();
	Rheostat_ADC_Mode_Config();
}

void Rheostat_Stop(void)
{
	DMA_Cmd(RHEOSTAT_ADC_DMA_STREAM, DISABLE);
	DMA_DeInit(RHEOSTAT_ADC_DMA_STREAM);
  // ADC DMA
  ADC_DMACmd(RHEOSTAT_ADC, DISABLE);
  // ADC
  ADC_Cmd(RHEOSTAT_ADC, DISABLE); 
	
}
/*********************************************END OF FILE**********************/
