/**
  ******************************************************************************
  * @file    bsp_key.c
  * @author  fire
  * @version V1.0
  * @date    2015-xx-xx
  * @brief   keyӦúӿ
  ******************************************************************************
  * @attention
  *
  * ʵƽ̨:  STM32 F429   
  * ̳    :http://www.firebbs.cn
  * Ա    :http://firestm32.taobao.com
  *
  ******************************************************************************
  */
#include "./Bsp/key/bsp_key.h"

/***************************************ûԶ庯***********************************/
/**
	************************************************************************************************************************
	*                              ܽ״̬ȡ
	*
	* ֻʺSTM32Ƭ⿪͵CPU޸ġ
	*
	*     
	*
	*   ֵڱ״̬ĵƽ1
	*           ڵ״̬ĵƽ0
	*
	************************************************************************************************************************
	*/

uint8_t GetPinStateOfKey1(void)
{
	if(GPIO_ReadInputDataBit(KEY1_GPIO_PORT,KEY1_PIN)==1)
	{
			return 1;
	}
	else
	{
			return 0;
	}
}
/*
************************************************************************************************************************
*                              1ܽųʼ
*
* ڰ1ʹ֮ǰȵ
*
*     
*
*   ֵ
*
************************************************************************************************************************
*/
void Key1_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	
	/*GPIOڵʱ*/
	RCC_AHB1PeriphClockCmd(KEY1_GPIO_CLK,ENABLE);
  /*ѡ񰴼*/
	GPIO_InitStructure.GPIO_Pin = KEY1_PIN; 
  /*Ϊģʽ*/
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN; 
  /*ŲҲ*/
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	/* ٶ */
	GPIO_InitStructure.GPIO_Speed= GPIO_Speed_2MHz;
  /*ʹĽṹʼ*/
	GPIO_Init(KEY1_GPIO_PORT, &GPIO_InitStructure);
}

/*
************************************************************************************************************************
*                              ܽ״̬ȡ
*
* ֻʺSTM32Ƭ⿪͵CPU޸ġ
*
*     
*
*   ֵڱ״̬ĵƽ1
*           ڵ״̬ĵƽ0
*
************************************************************************************************************************
*/

uint8_t GetPinStateOfKey2(void)
{
	if(GPIO_ReadInputDataBit(KEY2_GPIO_PORT,KEY2_PIN)==1)
	{
			return 1;
	}
	else
	{
			return 0;
	}
}

/*
************************************************************************************************************************
*                              2ܽųʼ
*
* ڰ2ʹ֮ǰȵ
*
*     
*
*   ֵ
*
************************************************************************************************************************
*/

void Key2_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	
	/*GPIOڵʱ*/
	RCC_AHB1PeriphClockCmd(KEY2_GPIO_CLK,ENABLE);
  /*ѡ񰴼*/
	GPIO_InitStructure.GPIO_Pin = KEY2_PIN; 
  /*Ϊģʽ*/
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN; 
  /*ŲҲ*/
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	/* ٶ */
	GPIO_InitStructure.GPIO_Speed= GPIO_Speed_2MHz;
  /*ʹĽṹʼ*/
	GPIO_Init(KEY2_GPIO_PORT, &GPIO_InitStructure);
}
/***************************************ûԶ庯***********************************/



/*
************************************************************************************************************************
*                              ʱ
*
* ûûжʱãûжKEY_FIXED_PERIODҪ¸CPUд˺
*
*     xms        ݲͬʱ䣬һ20ms
*
*   ֵ
*
*     ע⣺ʱ
*
************************************************************************************************************************
*/
#ifndef  KEY_FIXED_PERIOD
void key_delay1ms(uint8_t xms)
{
    
}
#endif


/*					ݲҪģֱʹü								*/
/*
************************************************************************************************************************
*                              
*
* ʹðǰҪ
*
*     p_Key        ָ򰴼Ʊָ
*           p_CallBack   ȡƽĻصָ룬ΪͬCPUƽȡķʽһⲿҪûԼд
*                        α£
*
*                          uint8_t GetPinStateOfKeyXX(void)
*                          {
*                            ܽŵĵƽǰʱĵƽ
*                            1
*
*                            ܽŵĵƽǰʱĵƽ
*                            0
*                          }
*
*   ֵڱ״̬ĵƽ1
*           ڵ״̬ĵƽ0
*
************************************************************************************************************************
*/
void KeyCreate(KEY *p_Key,KEY_CALLBACK_PTR p_CallBack)
{
  p_Key->GetStatePtr=p_CallBack;
  p_Key->Times=0;
  p_Key->State=KEY_UP;
  p_Key->StateChange=NOT_CHANGED;
#ifdef KEY_FIXED_PERIOD
	p_Key->Time_ms=0;          //ʱʼΪ0
#endif
  
#if USER_DATA_EN>0             
	p_Key->User_Data=0;		           //ûûʹ
#endif
  
}

/*
************************************************************************************************************************
*                              ״̬º
*
* ֻʺSTM32Ƭ⿪͵ĵƬ޸ġ
*
*     p_Key        ָ򰴼Ʊָ
*
*   ֵ
*
*     ע⣺ƵҪ20Hz
*
************************************************************************************************************************
*/
void Key_RefreshState(KEY* p_Key)
{
  switch(p_Key->State)
  {
    case KEY_UP:
    {
      if((*(p_Key->GetStatePtr))())//ִлصжϰܽ״̬
      {
#ifdef  KEY_FIXED_PERIOD   
        p_Key->Time_ms = 0;
        p_Key->State = KEY_DOWN_WOBBLE;//ʱ
#else
        p_Key->State = KEY_DOWN_WOBBLE;
        key_delay1ms(KEY_WOBBLE_TIME);				
        if((*(p_Key->GetStatePtr))())
        {
          p_Key->StateChange=CHANGED;
          p_Key->State = KEY_DOWN;
        }
#endif
      }
    }break;
    
    #ifdef  KEY_FIXED_PERIOD
    case KEY_DOWN_WOBBLE:
    {
      p_Key->Time_ms += KEY_FIXED_PERIOD;
      if( p_Key->Time_ms >=KEY_WOBBLE_TIME )
      {
        if((*(p_Key->GetStatePtr))())
        {
          p_Key->StateChange=CHANGED;
          p_Key->State = KEY_DOWN;
        }
        else
        {
          p_Key->State = KEY_UP;
        }
      }
    }break;
    #endif

    case KEY_DOWN:
    {
      if( (*(p_Key->GetStatePtr))() == 0 )
      {
#ifdef  KEY_FIXED_PERIOD
        p_Key->Time_ms = 0;
        p_Key->State = KEY_UP_WOBBLE;//ʱ
#else
        key_delay1ms(KEY_WOBBLE_TIME);
        if( (*(p_Key->GetStatePtr))() == 0 )
        {
          p_Key->StateChange=CHANGED;
          p_Key->State = KEY_UP;
          p_Key->Times++;
          if( p_Key->Times > 250)
            p_Key->Times = 250;//250û
        }
#endif
      }
    }break;

#ifdef  KEY_FIXED_PERIOD
    case KEY_UP_WOBBLE:
    {
      p_Key->Time_ms += KEY_FIXED_PERIOD;
      if( p_Key->Time_ms >= KEY_WOBBLE_TIME )
      {
        if( (*(p_Key->GetStatePtr))()==0)
        {
          p_Key->StateChange=CHANGED;
          p_Key->State = KEY_UP;
          p_Key->Times++;
          if( p_Key->Times > 250)
            p_Key->Times = 250;//250û
        }
        else
        {
          p_Key->State = KEY_DOWN;
        }
      }
    }break;
#endif
  }
}

/*
************************************************************************************************************************
*                              ´ʺ
*
* ԰´ķ
*
*     p_Key        ָ򰴼Ʊָ
*           option	     ѡڰһֻõһֲľûа
*                        KEY_ACCESS_READ         ȡµĴ
*                        KEY_ACCESS_WRITE_CLEAR  㰴µĴ
*   ֵ->timesֵ
*
*     ע⣺ʹûźͬһµKey_AccessTimesKey_RefreshState
*           ûʲôϵģϵͳоҪٽαˣ
*           һ㶼ҪһʹãΪÿεKey_RefreshStateTimesпܱ£ں
*           ѯ
*
************************************************************************************************************************
*/

uint8_t Key_AccessTimes(KEY* p_Key,ACCESS_TYPE opt)
{
	uint8_t times_temp;
	
	if((opt&KEY_ACCESS_WRITE_CLEAR) == KEY_ACCESS_WRITE_CLEAR)
	{
			p_Key->Times = 0;					
	}
		
	times_temp = p_Key->Times;
	
	return times_temp;
}

/*
************************************************************************************************************************
*                              ״̬ʺ
*
* ԰״̬ķ
*
*     p_Key        ָ򰴼Ʊָ

*   ֵ->Stateֵ
*
*     ע⣺1.ʹûźͬһµKey_AccessTimesKey_RefreshState
*           ûʲôϵģϵͳоҪٽαˣ
*           һ㶼ҪһʹãΪÿεKey_RefreshStateTimesпܱ£ں
*           ѯ
************************************************************************************************************************
*/
uint8_t Key_AccessState(KEY* p_Key,KEY_STATE *p_State)
{
  uint8_t StateChange=p_Key->StateChange;
  //ȡ״̬
  *p_State = p_Key->State;
  //ȡ״̬Ƿ񱻸ı
  p_Key->StateChange=NOT_CHANGED;
  //״̬Ƿı
  return StateChange;
}
