/**
  ******************************************************************************
  * @file    bsp_i2c_touch.c
  * @author  STMicroelectronics
  * @version V1.0
  * @date    2015-xx-xx
  * @brief   i2c(gt9xx)Ӧúbsp
  ******************************************************************************
  * @attention
  *
  * ʵƽ̨: iSO STM32  
  * ̳    :http://www.firebbs.cn
  * Ա    :http://firestm32.taobao.com
  *
  ******************************************************************************
  */ 

#include "./Bsp/touch/bsp_i2c_touch.h"
#include "./Bsp/touch/gt9xx.h"
#include "./Bsp/usart/bsp_debug_usart.h"


__IO uint32_t  I2CTimeout = I2CT_LONG_TIMEOUT;   


static void Delay(__IO uint32_t nCount)	 //򵥵ʱ
{
	for(; nCount != 0; nCount--);
}

/**
  * @brief  I2C1 I/O
  * @param  
  * @retval 
  */
static void I2C_GPIO_Config(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;  
   
  /*!< GTP_I2C Periph clock enable */
  RCC_APB1PeriphClockCmd(GTP_I2C_CLK, ENABLE);
  
  /*!< GTP_I2C_SCL_GPIO_CLK and GTP_I2C_SDA_GPIO_CLK Periph clock enable */
  RCC_AHB1PeriphClockCmd(GTP_I2C_SCL_GPIO_CLK | GTP_I2C_SDA_GPIO_CLK|GTP_RST_GPIO_CLK|GTP_INT_GPIO_CLK, ENABLE);

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);
 
#if !(SOFT_IIC)   //ʹӲIIC     
    /* I2C_SCLԴ*/
    GPIO_PinAFConfig(GTP_I2C_SCL_GPIO_PORT, 
                     GTP_I2C_SCL_SOURCE, GTP_I2C_SCL_AF);
    /* I2C_SDA Դ*/
    GPIO_PinAFConfig(GTP_I2C_SDA_GPIO_PORT, 
                     GTP_I2C_SDA_SOURCE, GTP_I2C_SDA_AF);  
    
    /*SCL */   
    GPIO_InitStructure.GPIO_Pin = GTP_I2C_SCL_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
    GPIO_Init(GTP_I2C_SCL_GPIO_PORT, &GPIO_InitStructure);

    /*SDA */
    GPIO_InitStructure.GPIO_Pin = GTP_I2C_SDA_PIN;
    GPIO_Init(GTP_I2C_SDA_GPIO_PORT, &GPIO_InitStructure);

#else  //ʹIIC
    /*SCL */   
    GPIO_InitStructure.GPIO_Pin = GTP_I2C_SCL_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
    GPIO_Init(GTP_I2C_SCL_GPIO_PORT, &GPIO_InitStructure);

    /*SDA */
    GPIO_InitStructure.GPIO_Pin = GTP_I2C_SDA_PIN;
    GPIO_Init(GTP_I2C_SDA_GPIO_PORT, &GPIO_InitStructure);
#endif
 
 
  /*!< Configure RST */   
  GPIO_InitStructure.GPIO_Pin = GTP_RST_GPIO_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
  GPIO_Init(GTP_RST_GPIO_PORT, &GPIO_InitStructure);
  
  /*!< Configure INT */   
  GPIO_InitStructure.GPIO_Pin = GTP_INT_GPIO_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_DOWN;       //Ϊʼ
  GPIO_Init(GTP_INT_GPIO_PORT, &GPIO_InitStructure);

}


/**
  * @brief  GT91xxоƬиλ
  * @param  
  * @retval 
  */
void I2C_ResetChip(void)
{
	  GPIO_InitTypeDef GPIO_InitStructure;

	  /*!< Configure INT */
	  GPIO_InitStructure.GPIO_Pin = GTP_INT_GPIO_PIN;
	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_DOWN;       //Ϊʼ
	  GPIO_Init(GTP_INT_GPIO_PORT, &GPIO_InitStructure);

	  /*ʼGT9157,rstΪߵƽintΪ͵ƽgt9157豸ַΪ0xBA*/

	  /*λΪ͵ƽΪʼ׼*/
	  GPIO_ResetBits (GTP_RST_GPIO_PORT,GTP_RST_GPIO_PIN);
	  Delay(0x0FFFFF);

	  /*һʱ䣬гʼ*/
	  GPIO_SetBits (GTP_RST_GPIO_PORT,GTP_RST_GPIO_PIN);
	  Delay(0x0FFFFF);

	  /*INTΪģʽ*/
	  /*!< Configure INT */
	  GPIO_InitStructure.GPIO_Pin = GTP_INT_GPIO_PIN;
	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
	  GPIO_Init(GTP_INT_GPIO_PORT, &GPIO_InitStructure);
}

#if !(SOFT_IIC) //ӲIICģʽ 

/**
  * @brief  I2C ģʽ
  * @param  
  * @retval 
  */
static void I2C_Mode_Config(void)
{
  I2C_InitTypeDef  I2C_InitStructure; 

  /* I2C  */
  I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;	
  I2C_InitStructure.I2C_DutyCycle = I2C_DutyCycle_2;		                    /* ߵƽȶ͵ƽݱ仯 SCL ʱߵռձ */
  I2C_InitStructure.I2C_OwnAddress1 =I2C_OWN_ADDRESS7;
  I2C_InitStructure.I2C_Ack = I2C_Ack_Enable ;	
  I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;	/* I2CѰַģʽ */
  I2C_InitStructure.I2C_ClockSpeed = I2C_Speed;	                            /* ͨ */
  I2C_Init(GTP_I2C, &I2C_InitStructure);	                                  /* I2C1 ʼ */
  I2C_Cmd(GTP_I2C, ENABLE);  	                                              /* ʹ I2C1 */

  I2C_AcknowledgeConfig(GTP_I2C, ENABLE);
  
//  I2C_GenerateSTOP (I2C1,DISABLE);
}
#endif

/**
  * @brief  I2C (GT91xx)ʼ
  * @param  
  * @retval 
  */
void I2C_Touch_Init(void)
{
  I2C_GPIO_Config(); 
 
#if !(SOFT_IIC) //ӲIICģʽ 
    I2C_Mode_Config();
#endif

  I2C_ResetChip();

}

#if !(SOFT_IIC) //ӲIICģʽ
/**
  * @brief  IICȴʱñϢ
  * @param  None.
  * @retval None.
  */
static  uint32_t I2C_TIMEOUT_UserCallback(void)
{
  GTP_ERROR("I2C Timeout error!");
  return 0xFF;
}


/**
  * @brief   ʹIICȡ
  * @param   
  * 	@arg ClientAddr:豸ַ
  *		@arg pBuffer:ɴӻȡݵĻָ
  *		@arg NumByteToRead:ȡݳ
  * @retval  
  */
uint32_t I2C_ReadBytes(uint8_t ClientAddr,uint8_t* pBuffer, uint16_t NumByteToRead)
{  
    I2CTimeout = I2CT_LONG_TIMEOUT;

    while(I2C_GetFlagStatus(GTP_I2C, I2C_FLAG_BUSY))   
    {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback();
    }

  /* Send STRAT condition  */
  I2C_GenerateSTART(GTP_I2C, ENABLE);
  
     I2CTimeout = I2CT_FLAG_TIMEOUT;

  /* Test on EV5 and clear it */
  while(!I2C_CheckEvent(GTP_I2C, I2C_EVENT_MASTER_MODE_SELECT))
    {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback();
   }
  /* Send GT91xx address for read */
  I2C_Send7bitAddress(GTP_I2C, ClientAddr, I2C_Direction_Receiver);
  
     I2CTimeout = I2CT_FLAG_TIMEOUT;

  /* Test on EV6 and clear it */
  while(!I2C_CheckEvent(GTP_I2C, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED))
    {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback();
   }
  /* While there is data to be read */
  while(NumByteToRead)  
  {
    if(NumByteToRead == 1)
    {
      /* Disable Acknowledgement */
      I2C_AcknowledgeConfig(GTP_I2C, DISABLE);
      
      /* Send STOP Condition */
      I2C_GenerateSTOP(GTP_I2C, ENABLE);
    }

    /* Test on EV7 and clear it */
    if(I2C_CheckEvent(GTP_I2C, I2C_EVENT_MASTER_BYTE_RECEIVED))  
    {      
      /* Read a byte from the EEPROM */
      *pBuffer = I2C_ReceiveData(GTP_I2C);

      /* Point to the next location where the byte read will be saved */
      pBuffer++; 
      
      /* Decrement the read bytes counter */
      NumByteToRead--;        
    }   
  }

  /* Enable Acknowledgement to be ready for another reception */
  I2C_AcknowledgeConfig(GTP_I2C, ENABLE);
  
  return 0;
}


/**
  * @brief   ʹIICд
  * @param   
  * 	@arg ClientAddr:豸ַ
  *		@arg pBuffer:ָ
  *     @arg NumByteToWrite:дֽ
  * @retval  
  */
uint32_t I2C_WriteBytes(uint8_t ClientAddr,uint8_t* pBuffer,  uint8_t NumByteToWrite)
{
  I2CTimeout = I2CT_LONG_TIMEOUT;

  while(I2C_GetFlagStatus(GTP_I2C, I2C_FLAG_BUSY))  
   {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback();
  } 
  
  /* Send START condition */
  I2C_GenerateSTART(GTP_I2C, ENABLE);
  
  
  I2CTimeout = I2CT_FLAG_TIMEOUT;

  /* Test on EV5 and clear it */
  while(!I2C_CheckEvent(GTP_I2C, I2C_EVENT_MASTER_MODE_SELECT))
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback();
  } 
  
  /* Send GT91xx address for write */
  I2C_Send7bitAddress(GTP_I2C, ClientAddr, I2C_Direction_Transmitter);
  
  I2CTimeout = I2CT_FLAG_TIMEOUT;

  /* Test on EV6 and clear it */
  while(!I2C_CheckEvent(GTP_I2C, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)) 
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback();
  } 
  /* While there is data to be written */
  while(NumByteToWrite--)  
  {
    /* Send the current byte */
    I2C_SendData(GTP_I2C, *pBuffer); 

    /* Point to the next byte to be written */
    pBuffer++; 
  
    I2CTimeout = I2CT_FLAG_TIMEOUT;

    /* Test on EV8 and clear it */
    while (!I2C_CheckEvent(GTP_I2C, I2C_EVENT_MASTER_BYTE_TRANSMITTED))
    {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback();
    } 
  }

  /* Send STOP condition */
  I2C_GenerateSTOP(GTP_I2C, ENABLE);
  
  return 0;
}


#else   //IICģʽ


/*
*********************************************************************************************************
*	  : i2c_Delay
*	˵: I2Cλӳ٣400KHz
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
static void i2c_Delay(void)
{
	uint8_t i;

	/*
	 	ʱͨ߼ǲԵõġ
    CPUƵ180MHz MDK뻷1Ż
      
		ѭΪ50ʱSCLƵ = 333KHz 
		ѭΪ30ʱSCLƵ = 533KHz  
	 	ѭΪ20ʱSCLƵ = 727KHz 
  */
	for (i = 0; i < 10*5; i++);
}

/*
*********************************************************************************************************
*	  : i2c_Start
*	˵: CPUI2Cź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Start(void)
{
	/* SCLߵƽʱSDAһرʾI2Cź */
	I2C_SDA_1();
	I2C_SCL_1();
	i2c_Delay();
	I2C_SDA_0();
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
}

/*
*********************************************************************************************************
*	  : i2c_Start
*	˵: CPUI2Cֹͣź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Stop(void)
{
	/* SCLߵƽʱSDAһرʾI2Cֹͣź */
	I2C_SDA_0();
	I2C_SCL_1();
	i2c_Delay();
	I2C_SDA_1();
}

/*
*********************************************************************************************************
*	  : i2c_SendByte
*	˵: CPUI2C豸8bit
*	    Σ_ucByte  ȴ͵ֽ
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_SendByte(uint8_t _ucByte)
{
	uint8_t i;

	/* ȷֽڵĸλbit7 */
	for (i = 0; i < 8; i++)
	{		
		if (_ucByte & 0x80)
		{
			I2C_SDA_1();
		}
		else
		{
			I2C_SDA_0();
		}
		i2c_Delay();
		I2C_SCL_1();
		i2c_Delay();	
		I2C_SCL_0();
		if (i == 7)
		{
			 I2C_SDA_1(); // ͷ
		}
		_ucByte <<= 1;	/* һbit */
		i2c_Delay();
	}
}

/*
*********************************************************************************************************
*	  : i2c_ReadByte
*	˵: CPUI2C豸ȡ8bit
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
uint8_t i2c_ReadByte(void)
{
	uint8_t i;
	uint8_t value;

	/* 1bitΪݵbit7 */
	value = 0;
	for (i = 0; i < 8; i++)
	{
		value <<= 1;
		I2C_SCL_1();
		i2c_Delay();
		if (I2C_SDA_READ())
		{
			value++;
		}
		I2C_SCL_0();
		i2c_Delay();
	}
	return value;
}

/*
*********************************************************************************************************
*	  : i2c_WaitAck
*	˵: CPUһʱӣȡACKӦź
*	    Σ
*	  ֵ: 0ʾȷӦ1ʾӦ
*********************************************************************************************************
*/
uint8_t i2c_WaitAck(void)
{
	uint8_t re;

	I2C_SDA_1();	/* CPUͷSDA */
	i2c_Delay();
	I2C_SCL_1();	/* CPUSCL = 1, ʱ᷵ACKӦ */
	i2c_Delay();
	if (I2C_SDA_READ())	/* CPUȡSDA״̬ */
	{
		re = 1;
	}
	else
	{
		re = 0;
	}
	I2C_SCL_0();
	i2c_Delay();
	return re;
}

/*
*********************************************************************************************************
*	  : i2c_Ack
*	˵: CPUһACKź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Ack(void)
{
	I2C_SDA_0();	/* CPUSDA = 0 */
	i2c_Delay();
	I2C_SCL_1();	/* CPU1ʱ */
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
	I2C_SDA_1();	/* CPUͷSDA */
}

/*
*********************************************************************************************************
*	  : i2c_NAck
*	˵: CPU1NACKź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_NAck(void)
{
	I2C_SDA_1();	/* CPUSDA = 1 */
	i2c_Delay();
	I2C_SCL_1();	/* CPU1ʱ */
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();	
}



#define I2C_DIR_WR	0		/* дbit */
#define I2C_DIR_RD	1		/* bit */

/**
  * @brief   ʹIICȡ
  * @param   
  * 	@arg ClientAddr:豸ַ
  *		@arg pBuffer:ɴӻȡݵĻָ
  *		@arg NumByteToRead:ȡݳ
  * @retval  
  */
uint32_t I2C_ReadBytes(uint8_t ClientAddr,uint8_t* pBuffer, uint16_t NumByteToRead)
{
	
	/* 1I2Cź */
	i2c_Start();
	
	/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
	i2c_SendByte(ClientAddr | I2C_DIR_RD);	/* ˴Ƕָ */
	
	/* 3ȴACK */
	if (i2c_WaitAck() != 0)
	{
		goto cmd_fail;	/* Ӧ */
	}

	while(NumByteToRead) 
  {
   if(NumByteToRead == 1)
    {
			i2c_NAck();	/* 1ֽڶCPUNACKź(SDA = 1) */
      
      /* I2Cֹͣź */
      i2c_Stop();
    }
    
   *pBuffer = i2c_ReadByte();
    
    /* ָ */
    pBuffer++; 
      
    /*Լ */
    NumByteToRead--;
    
    i2c_Ack();	/* мֽڶCPUACKź(SDA = 0) */  
  }

	/* I2Cֹͣź */
	i2c_Stop();
	return 0;	/* ִгɹ */

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
	/* I2Cֹͣź */
	i2c_Stop();
	return 1;
}

/**
  * @brief   ʹIICд
  * @param   
  * 	@arg ClientAddr:豸ַ
  *		@arg pBuffer:ָ
  *     @arg NumByteToWrite:дֽ
  * @retval  
  */
uint32_t I2C_WriteBytes(uint8_t ClientAddr,uint8_t* pBuffer,  uint8_t NumByteToWrite)
{
	uint16_t m;	

  /*0ֹͣźţڲд*/
  i2c_Stop();
  
  /* ͨӦķʽжڲдǷ, һС 10ms 			
    CLKƵΪ200KHzʱѯΪ30
  */
  for (m = 0; m < 1000; m++)
  {				
    /* 1I2Cź */
    i2c_Start();
    
    /* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
    i2c_SendByte(ClientAddr | I2C_DIR_WR);	/* ˴дָ */
    
    /* 3һʱӣжǷȷӦ */
    if (i2c_WaitAck() == 0)
    {
      break;
    }
  }
  if (m  == 1000)
  {
    goto cmd_fail;	/* EEPROMдʱ */
  }	
	
  while(NumByteToWrite--)
  {
  /* 4ʼд */
  i2c_SendByte(*pBuffer);

  /* 5ACK */
  if (i2c_WaitAck() != 0)
  {
    goto cmd_fail;	/* Ӧ */
  }
  
      pBuffer++;	/* ַ1 */		
  }
	
	/* ִгɹI2Cֹͣź */
	i2c_Stop();
	return 0;

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
	/* I2Cֹͣź */
	i2c_Stop();
	return 1;
}

#endif


/*********************************************END OF FILE**********************/
